import { useMemo } from 'react';

import { useProductImportsMeta, useSearchProductImports } from '@api/catalog/imports';
import { ProductImportData } from '@api/catalog/types/imports';

import { useError } from '@context/modal';

import { PageTemplate } from '@components/PageTemplate';
import PageWrapper from '@components/PageWrapper';
import Table, { useSorting, useTable } from '@components/Table';
import { getSettingsColumn } from '@components/Table/columns';
import { TableEmpty, TableFooter } from '@components/Table/components';

import { getPagination, getTotalPages } from '@scripts/helpers';
import { useRedirectToNotEmptyPage, useTableList } from '@scripts/hooks';
import { useAutoColumns, useAutoFilters, useAutoTableData } from '@scripts/hooks/autoTable';

import { useImportAccess } from './useImportAccess';

const ImportLogs = () => {
    const access = useImportAccess();

    const { data: apiMeta, error: metaError, isFetching: isMetaLoading } = useProductImportsMeta(access.ID.logsView);
    useError(metaError);

    const meta = apiMeta?.data;

    const { codesToSortKeys, metaField, filtersActive, searchRequestFilter, reset } = useAutoFilters(meta);

    const { activePage, itemsPerPageCount, setItemsPerPageCount } = useTableList({
        defaultSort: meta?.default_sort,
        codesToSortKeys,
    });

    const [{ backendSorting }, sortingPlugin] = useSorting<ProductImportData>('import_logs', meta?.fields);

    const {
        data,
        isFetching: isLoading,
        error,
    } = useSearchProductImports(
        {
            sort: backendSorting,
            filter: searchRequestFilter,
            pagination: getPagination(activePage, itemsPerPageCount),
        },
        Boolean(meta) && !!backendSorting
    );
    useError(error);

    const rows = useAutoTableData<ProductImportData>(data?.data, metaField);
    const autoGeneratedColumns = useAutoColumns(meta, false);

    const columns = useMemo(
        () => [
            ...autoGeneratedColumns,
            getSettingsColumn({ columnsToDisable: [], visibleColumns: meta?.default_list, hasCell: false }),
        ],
        [autoGeneratedColumns, meta?.default_list]
    );

    const totalPages = getTotalPages(data, itemsPerPageCount);

    useRedirectToNotEmptyPage({ activePage, itemsPerPageCount, total: data?.meta.pagination?.total });

    const table = useTable(
        {
            data: rows,
            columns,
            meta: {
                tableKey: `import_logs`,
            },
        },
        [sortingPlugin]
    );

    return (
        <PageWrapper title="Журнал импортов" isLoading={isMetaLoading || isLoading} isForbidden={!access.ID.logsView}>
            <PageTemplate
                h1="Журнал импортов"
                backlink={{
                    href: '/products/import',
                    text: 'Назад',
                }}
            >
                {columns.length && <Table instance={table} />}
                {rows.length === 0 && !isLoading ? (
                    <TableEmpty
                        filtersActive={filtersActive}
                        titleWithFilters="Записи не найдены"
                        titleWithoutFilters="Записей нет"
                        addItems={() => setItemsPerPageCount(10)}
                        onResetFilters={reset}
                    />
                ) : (
                    <TableFooter
                        pages={totalPages}
                        itemsPerPageCount={itemsPerPageCount}
                        setItemsPerPageCount={setItemsPerPageCount}
                    />
                )}
            </PageTemplate>
        </PageWrapper>
    );
};

export default ImportLogs;
